import { world } from "@minecraft/server"

world.events.worldInitialize.subscribe(()=>{
    world.getDimension(`overworld`).runCommandAsync(`say load`)
})

// let x = world.getDimension(`overworld`)
let playersReady=0
let once=false
let once2=false
let once3=false
let wait=0
world.events.tick.subscribe(() => {
    let players = Array.from(world.getPlayers());

    world.getDimension(`overworld`).runCommandAsync(`function shepherd/.main`)
    world.getDimension(`overworld`).runCommandAsync(`scoreboard players add @a[tag=playing] time 1`)

    world.getDimension(`overworld`).runCommandAsync(`execute as @a[tag=!quest2] at @s if block ~ -57 ~-0.2 concrete 14 run tp @s ~~~0.2`)
    world.getDimension(`overworld`).runCommandAsync(`function shepherd/.effects`)
    world.getDimension(`overworld`).runCommandAsync(`execute positioned 85 -42 56 as @a[r=2] run tag @a add end`)

    for(let player of players){
        try{
        if(!player.hasTag(`loaded`)){
            player.runCommandAsync(`tp @s -25 -42 417 facing -25 -42 400`)
            player.runCommandAsync(`clear @s`)
            player.runCommandAsync(`give @s shark:ready 1 0 {"minecraft:item_lock":{"mode":"lock_in_inventory"}}`)
            player.addTag(`loaded`)
        }
        if(!player.hasTag(`playing`) && !player.hasTag(`ready`))player.runCommandAsync(`title @s actionbar §4${playersReady}/${players.length}`)
        if(!player.hasTag(`playing`) && player.hasTag(`ready`))player.runCommandAsync(`title @s actionbar §a${playersReady}/${players.length}`)

        if(playersReady==players.length && once3==false)wait++

        if(playersReady==players.length && once3==false && wait==120){
            world.getDimension(`overworld`).runCommandAsync(`function shepherd/start`)
            once3=true
        }
        }catch{}
        // wait


        //joshs sound effect
        player.runCommandAsync(`execute positioned 35 -46 103 as @a[r=3,tag=!event2] run playsound ambient.cave @s`)
        player.runCommandAsync(`execute positioned 35 -46 103 as @a[r=3,tag=!event2] run tag @s add event2`)


        //quest1
        if(player.hasTag(`quest1`)){
            player.runCommandAsync(`title @a actionbar Sheep found: §a${sheep_found}/${sheep_total}`)
        }
        if(player.hasTag(`quest2`)){
            player.runCommandAsync(`title @a actionbar §aGo to Bethlehem`)
        }
        if(sheep_found==19 && once2==false){
            player.runCommandAsync(`function shepherd/sheepsummonlast`)
            once2=true
        }
        if(sheep_found==sheep_total && once==false){
            player.runCommandAsync(`tag @a[c=1] add angel`)
            once = true
        }
        
    }
})


let sheep_total = 20
let sheep_found = 0
world.events.entityHit.subscribe((hitEvent)=>{
    let player = hitEvent.entity
    let hit = hitEvent.hitEntity

    if(hit.typeId==`minecraft:sheep` && hit.nameTag != 'sheepiguess' && !player.hasTag(`quest2`)){
        sheep_found++
        player.runCommandAsync(`execute as @a at @s run playsound random.orb`)
        hit.runCommandAsync(`tp @s -7 -53 328`)
    }
})


world.events.itemUse.subscribe((itemused)=>{
    if(itemused.item.typeId=='shark:ready'){
        playersReady++
        itemused.source.runCommandAsync(`clear @s shark:ready`)
        itemused.source.runCommandAsync(`give @s shark:unready`)
        itemused.source.runCommandAsync(`playsound random.pop`)
        itemused.source.addTag(`ready`)
    }
    if(itemused.item.typeId=='shark:unready'){
        playersReady--
        itemused.source.runCommandAsync(`clear @s shark:unready`)
        itemused.source.runCommandAsync(`give @s shark:ready`)
        itemused.source.runCommandAsync(`playsound random.pop`) 
        itemused.source.removeTag(`ready`)
    }
})